Adriana Kobylak | e882f91 | 2017-07-06 10:31:59 -0500 | [diff] [blame] | 1 | #!/bin/sh |
| 2 | |
| 3 | # Get the mtd device number (mtdX) |
| 4 | findmtd() { |
| 5 | m="$(grep -xl "$1" /sys/class/mtd/*/name)" |
| 6 | m="${m%/name}" |
| 7 | m="${m##*/}" |
| 8 | echo "${m}" |
| 9 | } |
| 10 | |
Adriana Kobylak | f15e77c | 2017-07-06 11:26:42 -0500 | [diff] [blame] | 11 | # Get the ubi device number (ubiX_Y) |
| 12 | findubi() { |
| 13 | u="$(grep -xl "$1" /sys/class/ubi/ubi?/subsystem/ubi*/name)" |
| 14 | u="${u%/name}" |
| 15 | u="${u##*/}" |
| 16 | echo "${u}" |
| 17 | } |
| 18 | |
| 19 | # Get the mount information |
| 20 | is_mounted() { |
| 21 | grep -q "$1" /proc/mounts |
| 22 | return $? |
| 23 | } |
| 24 | |
Saqib Khan | ce61193 | 2017-08-01 09:46:22 -0500 | [diff] [blame^] | 25 | # Attach the pnor mtd device to ubi. |
Adriana Kobylak | e882f91 | 2017-07-06 10:31:59 -0500 | [diff] [blame] | 26 | attach_ubi() { |
| 27 | pnormtd="$(findmtd pnor)" |
| 28 | pnor="${pnormtd#mtd}" |
| 29 | pnordev="/dev/mtd${pnor}" |
| 30 | |
| 31 | ubiattach /dev/ubi_ctrl -m "${pnor}" -d "${pnor}" |
| 32 | rc=$? |
| 33 | if [ ${rc} -ne 0 ]; then |
| 34 | # Check the pnor mtd device is formatted as ubi by reading the first 3 byes, |
| 35 | # which should be the ascii chars 'UBI' |
| 36 | magic="$(hexdump -C -n 3 ${pnordev})" |
| 37 | if [[ "${magic}" =~ "UBI" ]]; then |
| 38 | # Device already formatted as ubi, ubiattach failed for some other reason |
| 39 | return ${rc} |
| 40 | else |
| 41 | # Format device as ubi |
| 42 | echo "Starting ubiformat ${pnordev}" |
| 43 | ubiformat "${pnordev}" -y -q |
| 44 | # Retry the ubiattach |
| 45 | ubiattach /dev/ubi_ctrl -m "${pnor}" -d "${pnor}" |
| 46 | fi |
| 47 | fi |
| 48 | } |
| 49 | |
Adriana Kobylak | f15e77c | 2017-07-06 11:26:42 -0500 | [diff] [blame] | 50 | mount_squashfs() { |
| 51 | pnormtd="$(findmtd pnor)" |
| 52 | pnor="${pnormtd#mtd}" |
| 53 | ubidev="/dev/ubi${pnor}" |
| 54 | mountdir="/media/${name}" |
| 55 | |
| 56 | if [ ! -d "${mountdir}" ]; then |
| 57 | mkdir "${mountdir}" |
| 58 | fi |
| 59 | |
Adriana Kobylak | d316559 | 2017-07-18 12:24:24 -0500 | [diff] [blame] | 60 | # Create a static ubi volume of arbitrary size 24MB, |
| 61 | # the current pnor image is ~19MB |
| 62 | # TODO Set size based on file size openbmc/openbmc#1840 |
Adriana Kobylak | f15e77c | 2017-07-06 11:26:42 -0500 | [diff] [blame] | 63 | vol="$(findubi "${name}")" |
| 64 | if [ -z "${vol}" ]; then |
Adriana Kobylak | d316559 | 2017-07-18 12:24:24 -0500 | [diff] [blame] | 65 | ubimkvol "${ubidev}" -N "${name}" -s 24MiB --type=static |
Adriana Kobylak | f15e77c | 2017-07-06 11:26:42 -0500 | [diff] [blame] | 66 | vol="$(findubi "${name}")" |
| 67 | fi |
| 68 | |
| 69 | # Create a ubi block needed for read-only volumes, |
| 70 | # and update the volume with the pnor squashfs image |
| 71 | ubidevid="${vol#ubi}" |
| 72 | block="/dev/ubiblock${ubidevid}" |
| 73 | if [ ! -e "$block" ]; then |
| 74 | img="/tmp/images/${version}/pnor.xz.squashfs" |
| 75 | ubiblock --create "/dev/ubi${ubidevid}" |
| 76 | ubiupdatevol "/dev/ubi${ubidevid}" "${img}" |
| 77 | fi |
| 78 | |
| 79 | if ! is_mounted "${name}"; then |
| 80 | mount -t squashfs -o ro "${block}" "${mountdir}" |
| 81 | fi |
| 82 | } |
| 83 | |
Adriana Kobylak | 6aff574 | 2017-07-06 11:29:46 -0500 | [diff] [blame] | 84 | mount_ubi() { |
| 85 | pnormtd="$(findmtd pnor)" |
| 86 | pnor="${pnormtd#mtd}" |
| 87 | ubidev="/dev/ubi${pnor}" |
| 88 | mountdir="/media/${name}" |
| 89 | |
Adriana Kobylak | d316559 | 2017-07-18 12:24:24 -0500 | [diff] [blame] | 90 | if [[ "${name}" == "pnor-prsv" ]]; then |
| 91 | size="2MiB" |
| 92 | else |
| 93 | size="16MiB" |
| 94 | fi |
| 95 | |
Adriana Kobylak | 6aff574 | 2017-07-06 11:29:46 -0500 | [diff] [blame] | 96 | if [ ! -d "${mountdir}" ]; then |
| 97 | mkdir "${mountdir}" |
| 98 | fi |
| 99 | |
Adriana Kobylak | 6aff574 | 2017-07-06 11:29:46 -0500 | [diff] [blame] | 100 | vol="$(findubi "${name}")" |
| 101 | if [ -z "${vol}" ]; then |
Adriana Kobylak | d316559 | 2017-07-18 12:24:24 -0500 | [diff] [blame] | 102 | ubimkvol "${ubidev}" -N "${name}" -s "${size}" |
Adriana Kobylak | 6aff574 | 2017-07-06 11:29:46 -0500 | [diff] [blame] | 103 | fi |
| 104 | |
| 105 | if ! is_mounted "${name}"; then |
| 106 | mountdev="ubi${pnor}:${name}" |
| 107 | mount -t ubifs "${mountdev}" "${mountdir}" |
| 108 | fi |
| 109 | } |
| 110 | |
Adriana Kobylak | e5764af | 2017-06-07 15:24:52 -0500 | [diff] [blame] | 111 | umount_ubi() { |
| 112 | pnormtd="$(findmtd pnor)" |
| 113 | pnor="${pnormtd#mtd}" |
| 114 | ubidev="/dev/ubi${pnor}" |
| 115 | mountdir="/media/${name}" |
| 116 | |
| 117 | if is_mounted "${name}"; then |
| 118 | umount "${mountdir}" |
| 119 | fi |
| 120 | |
| 121 | vol="$(findubi "${name}")" |
| 122 | if [ -n "${vol}" ]; then |
| 123 | ubirmvol "${ubidev}" -N "${name}" |
| 124 | fi |
| 125 | |
| 126 | if [ -d "${mountdir}" ]; then |
| 127 | rm -r "${mountdir}" |
| 128 | fi |
| 129 | } |
| 130 | |
Saqib Khan | 58c870d | 2017-07-26 23:48:20 -0500 | [diff] [blame] | 131 | remount_ubi() { |
| 132 | pnormtd="$(findmtd pnor)" |
| 133 | pnor="${pnormtd#mtd}" |
Saqib Khan | ce61193 | 2017-08-01 09:46:22 -0500 | [diff] [blame^] | 134 | pnordev="/dev/mtd${pnor}" |
| 135 | |
| 136 | # Re-Attach the pnor mtd device to ubi |
| 137 | ubiattach /dev/ubi_ctrl -m "${pnor}" -d "${pnor}" |
| 138 | rc=$? |
| 139 | if [ ${rc} -ne 0 ]; then |
| 140 | # Check the pnor mtd device is formatted as ubi by reading |
| 141 | # the first 3 byes, which should be the ascii chars 'UBI' |
| 142 | magic="$(hexdump -C -n 3 ${pnordev})" |
| 143 | if [[ ! "${magic}" =~ "UBI" ]]; then |
| 144 | # Device not formatted as ubi. |
| 145 | return |
| 146 | fi |
| 147 | fi |
| 148 | |
Saqib Khan | 58c870d | 2017-07-26 23:48:20 -0500 | [diff] [blame] | 149 | # Get information on all ubi volumes |
| 150 | ubinfo=$(ubinfo -d ${pnor}) |
| 151 | presentVolumes=${ubinfo##*:} |
| 152 | IFS=', ' read -r -a array <<< "$presentVolumes" |
| 153 | for element in ${array[@]}; |
| 154 | do |
| 155 | elementProperties=$(ubinfo -d $pnor -n $element) |
| 156 | # Get ubi volume name by getting rid of additional properties |
| 157 | name=${elementProperties#*Name:} |
| 158 | name="${name%Character*}" |
| 159 | name="$(echo -e "${name}" | tr -d '[:space:]')" |
| 160 | |
| 161 | if [[ ${name} == pnor-prsv ]] || [[ ${name} == pnor-rw* ]] || [[ ${name} == pnor-ro* ]]; then |
| 162 | mountdir="/media/${name}" |
| 163 | if [[ ${name} == pnor-ro* ]] |
| 164 | then |
| 165 | ubiblock --create /dev/ubi${pnor}_${element} |
| 166 | mount -t squashfs -o ro "/dev/ubiblock${pnor}_${element}" "${mountdir}" |
| 167 | else |
| 168 | mount -t ubifs "ubi${pnor}:${name}" "${mountdir}" |
| 169 | fi |
| 170 | fi |
| 171 | done |
| 172 | } |
| 173 | |
Adriana Kobylak | e882f91 | 2017-07-06 10:31:59 -0500 | [diff] [blame] | 174 | case "$1" in |
| 175 | ubiattach) |
| 176 | attach_ubi |
| 177 | ;; |
Adriana Kobylak | f15e77c | 2017-07-06 11:26:42 -0500 | [diff] [blame] | 178 | squashfsmount) |
| 179 | name="$2" |
| 180 | version="$3" |
| 181 | mount_squashfs |
| 182 | ;; |
Adriana Kobylak | 6aff574 | 2017-07-06 11:29:46 -0500 | [diff] [blame] | 183 | ubimount) |
| 184 | name="$2" |
| 185 | mount_ubi |
| 186 | ;; |
Adriana Kobylak | e5764af | 2017-06-07 15:24:52 -0500 | [diff] [blame] | 187 | ubiumount) |
| 188 | name="$2" |
| 189 | umount_ubi |
| 190 | ;; |
Saqib Khan | 58c870d | 2017-07-26 23:48:20 -0500 | [diff] [blame] | 191 | ubiremount) |
| 192 | remount_ubi |
| 193 | ;; |
Adriana Kobylak | e882f91 | 2017-07-06 10:31:59 -0500 | [diff] [blame] | 194 | *) |
| 195 | echo "Invalid argument" |
| 196 | exit 1 |
| 197 | ;; |
| 198 | esac |
| 199 | rc=$? |
| 200 | if [ ${rc} -ne 0 ]; then |
| 201 | echo "$0: error ${rc}" |
| 202 | exit ${rc} |
| 203 | fi |